#include <cstdio>
#include <cstdlib>
#include <cstring>

const int NMax = 1000;
int p[NMax];
int n;

bool next();

int main()
{
	const char *InFile = "MUSEUM.DAT";
	const char *OutFile = "MUSEUM.SOL";
	
	int i, mod;
	char place[NMax][NMax];
	
	freopen(InFile, "rt", stdin);
	scanf("%d%d", &n, &mod);
	for (i=0; i<n; i++)
		p[i] = i+1;
	memset(place, 0, sizeof(place));
	for (i=0; i<n; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		place[a][b] = 1;
		place[b][a] = 1;
		place[i+1][i+1] = 1;
	}
	fclose(stdin);
	
	int count = 0, cnt = 0;
	
	freopen(OutFile, "wt", stdout);	
	do {
		bool notprint = false;
		count++;
		for (i=0; i<n; i++) {
			if (!place[i+1][p[i]]) {
				count--;
				notprint = true;
				break;
			}
		}
		/*if (notprint) {
			printf("-");
		}
		for (i=0; i<n; i++)
			printf("%d ", p[i]);
		printf("\n");*/
		cnt++;
	} while (next());

	printf("%d\n", count);
	fclose(stdout);
	
	return 0;
}

bool next()
{
	int i, j, saved = -1;
	for (i=n-1; i>0; i--) {
		if (p[i-1]<p[i]) {
			saved = i-1;
			break;
		}
	}
	if (saved == -1)
		return false;
	int ps = p[saved];
	int save2;
	for (i=n-1; i>=saved; i--) {
		if (p[i]>=ps) {
			save2 = i;
			break;
		}
	}
	int buf = ps;
	p[saved] = p[save2];
	p[save2] = buf;
	i = saved+1;
	j = n-1;
	while (i<j) {
		buf = p[i];
		p[i] = p[j];
		p[j] = buf;
		i++;
		j--;
	}
	return true;
}
